/* public things from tcp.c */

#ifndef _TCP_H_
#define _TCP_H_

extern int tcp_fd;		/* socket file descriptor */
extern int tcp_main_fd;		/* main session socket */
extern int tcp_count;		/* number of open connections */
extern int tcp_attachcount;	/* number of spawned or attached commands */

/* multiple connections control */
typedef struct {
    int active;			/* display remote output? */
    int mode;			/* 0: mud-like connection;
				 * 1: keyboard-like connection */
    char *id;			/* session id */
    char *host;			/* address of remote host */
    int port;			/* port number of remote host */
} connsess;

extern connsess conn_list[MAX_FDSCAN];     /* connections indexed by socket descrs */
#define TCP_MIN_FD 3			   /* descriptors 0,1,2 are already used */
#define CONN_LIST(n) conn_list[n-TCP_MIN_FD]

extern fd_set fdset;               /* set of descriptors to select() on */

int  tcp_connect	__P ((char *addr, int port));
int  tcp_read		__P ((int fd, char *buffer, int maxsize));
void tcp_raw_write	__P ((int fd, char *data, int len));
void tcp_write_tty_size __P ((void));
void tcp_write		__P ((int fd, char *data));
void tcp_main_write	__P ((char *data));
void tcp_flush		__P ((void));
void tcp_set_main	__P ((int fd));
void tcp_open		__P ((char *id, char *initstring, char *host, int port));
int  tcp_find		__P ((char *id));
void tcp_show		__P ((void));
void tcp_close		__P ((char *id));
void tcp_togglesnoop	__P ((char *id));
void tcp_spawn		__P ((char *id, char *cmd));

#endif /* _TCP_H_ */

